﻿namespace UninitializedOutViaException {
	class Program {

		static void g(out int a, int c) {
			if (c > 4) {
				throw new ArgumentOutOfRangeException(nameof(c));
			}
			if (c < 0) {
				int.Parse("NOT-A-NUMBER");
			}
			a = 123;
		}

		static void f1() {
			int b;
			g(out b, 10);
			Console.WriteLine(b);
		}

		static void f2() {
			try {
				int b;
				g(out b, -1);
				Console.WriteLine(b);
			} catch {
				// Error: The name 'b' does not exist in the current context
				// Console.WriteLine(b);
				Console.WriteLine("+++ Exception in f2 +++");
				throw;
			}
		}

		static void f3(int value) {
			int b;
			try {
				g(out b, value);
				Console.WriteLine(b);
			} catch {
				// Error: Use of unassigned local variable 'b'
				// Console.WriteLine(b);
				Console.WriteLine("+++ Exception in f3 +++");
				throw;
			}
			Console.WriteLine(b);
		}

		static void f4(int value) {
			int b;
			try {
				g(out b, value);
				Console.WriteLine(b);
			} catch {
				// Error: Use of unassigned local variable 'b'
				// Console.WriteLine(b);
				Console.WriteLine("+++ Exception in f4 +++");
			}
			// Error: Use of unassigned local variable 'b'
			// Console.WriteLine(b);
		}

		static void Main(string[] args) {
			try { f1(); } catch (Exception ex) { Console.WriteLine(ex); }
			Console.WriteLine("-----");
			try { f2(); } catch (Exception ex) { Console.WriteLine(ex); }
			Console.WriteLine("-----");
			try { f3(-1); } catch (Exception ex) { Console.WriteLine(ex); }
			Console.WriteLine("-----");
			try { f3(1); } catch (Exception ex) { Console.WriteLine(ex); }
			Console.WriteLine("-----");
			try { f4(-1); } catch (Exception ex) { Console.WriteLine(ex); }
		}
	}
}