﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OutVariableDeclaration {
	class Program {
		static void Main(string[] args) {

			{
				string s = "42";
				int x;
				if (int.TryParse(s, out x)) {
					Console.WriteLine($"in if: {x}");
				} else {
					Console.WriteLine($"in else: {x}");
				}
				Console.WriteLine($"after if: {x}");
			}

			{
				string s = "42";
				if (int.TryParse(s, out int x)) {
					Console.WriteLine($"in if: {x}");
				} else {
					Console.WriteLine($"in else: {x}");
				}
				Console.WriteLine($"after if: {x}");
			}

			// Error: The name 'x' does not exist in the current context
			// Console.WriteLine($"after block: {x}");

			{
				string s = "100";
				if (int.TryParse(s, out var x)) {
					Console.WriteLine($"in if: {x}");
				}
				Console.WriteLine($"after if: {x}");
			}

			Console.WriteLine();

			{
				string s = "THIS-IS-NOT-A-NUMBER";
				int x = 123;	// BUG: This "default" value will be overwritten by int.TryParse!!!
				if (int.TryParse(s, out x)) {
					Console.WriteLine($"in if: {x}");
				}
				Console.WriteLine($"after if: {x}");
			}
		}
	}
}
