﻿using System;

namespace DiscardOutParameters {
	class Program {
		static int f(out int a, out int b, out int c) {
			a = b = c = 123;
			return 42;
		}

		static void Main(string[] args) {

			var result = f(out _, out var b, out _);

			// Error: A local variable or function named 'a' is already defined in this scope
			// f(out var a, out var a, out var a);

			// Error: A local variable or function named 'b' is already defined in this scope
			// f(out _, out var b, out var c);

			// Uncomment this:
			// var _ = 256;
			// and code above will have error:
			// Error: Cannot use local variable '_' before it is declared

			Console.WriteLine(b);

			_ = f(out _, out _, out var c);
		
			Console.WriteLine(c);

			Console.WriteLine("---");

			int u = 8;
			Console.WriteLine(u);

			g(ref u);

			Console.WriteLine(u);
		}

		static void g(ref int _) {
			// ...
			var x = f(out _, out _, out _);
			Console.WriteLine(x);
		}
	}
}
