// CppValueTypeLikeFieldInheritance.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>

struct SX {
    int32_t a;

    void print_a() {
        printf("SX: this ==   0x%p\n", this);
        printf("SX: this->a @ 0x%p == %d\n", &(this->a), this->a);
    }
};

struct S1 {
    int32_t a;

    virtual void print_a() {
        printf("S1: this ==   0x%p\n", this);
        printf("S1: this->a @ 0x%p == %d\n", &(this->a), this->a);
    }

    void nonvirtual_print() {
        this->print_a();
    }
};

struct S2 : S1 {
    int32_t b;

    void print_a() override {
        printf("S2: this ==   0x%p\n", this);
        printf("S2: this->a @ 0x%p == %d\n", &(this->a), this->a);
        printf("S2: this->b @ 0x%p == %d\n", &(this->b), this->b);
    }
};

int main()
{
    SX sx{};
    sx.a = 11;
    printf(">>> sx.print_a() >>>\n");
    sx.print_a();
    printf("sizeof(sx): %zd B\n", sizeof(sx));
    printf("\n");

    S1 s1{};
    s1.a = 22;
    printf(">>> s1.print_a() >>>\n");
    s1.print_a();
    printf("sizeof(s1): %zd B\n", sizeof(s1));
    printf("\n");

    S2 s2{};
    s2.a = 33;
    s2.b = 333;
    printf(">>> s2.print_a() >>>\n");
    s2.print_a();
    printf("sizeof(s2): %zd B\n", sizeof(s2));
    printf("\n");

    printf(">>> s1 = s2;\n");
    printf(">>> s1.print_a() >>>\n");

    s1 = s2;
    s1.print_a();
    printf("\n");

    // Compile error: no suitable user - defined conversion from "S1" to "S2" exists
    // s2 = (S2) s1;

    printf("---\n\n");

    S1 *s1ptr = new S1();
    s1ptr->a = 200;
    printf(">>> s1ptr->print_a() >>>\n");
    s1ptr->print_a();
    printf("sizeof(s1ptr): %zd B\n", sizeof(s1ptr));
    printf("\n");

    S2* s2ptr = new S2();
    s2ptr->a = 300;
    s2ptr->b = 3000;
    printf(">>> s2ptr->print_a() >>>\n");
    s2ptr->print_a();
    printf("sizeof(s2ptr): %zd B\n", sizeof(s2ptr));
    printf("\n");

    printf(">>> s1ptr = s2ptr;\n");
    s1ptr = s2ptr;
    printf(">>> s1ptr->print_a() >>>\n");
    s1ptr->print_a();
    printf("\n");

    // Note: neither S1 nor S2 instances allocated by "new" above are not "delete"ed, so they are memory leaks here!
    printf("---\n\n");

    s1ptr = &s1;
    s1ptr->print_a();
    printf("\n");

    s1ptr = &s2;
    s1ptr->print_a();
    printf("\n");

    printf("+++ nonvirtual_print +++\n\n");

    s1ptr->nonvirtual_print();
    printf("\n");
    s1.nonvirtual_print();
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

