﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace InReferences {

	struct Point {
		public int X;
		public int Y;
		public int Z;
	}

	class Program {

		public static void InitPoint(out Point p) {
			p.X = 1;
			p.Y = 2;
			p.Z = 3;
		}

		public static void CopyPoint(out Point target, in Point source) {
			target.X = source.X;
			target.Y = source.Y;
			target.Z = source.Z;

			// Error: Cannot assign to a member of variable 'in Point' because it is a readonly variable
			// source.X = 42;
		}

		public static void TestReadonlyness(in Point p1, ref Point p2) {
			Console.WriteLine($"Reading p1.X: {p1.X} ... and now modifying p2.X ...");
			p2.X = 123;
			Console.WriteLine($"Reading p1.X: {p1.X}");
		}

		static void Main(string[] args) {
			for (int i = 0; i < 5; i++) {
				Point p1;
				Point p2;

				// Error: Use of possibly unassigned field 'X'
				// Console.WriteLine(p1.X);
				// Console.WriteLine(p2.X);

				InitPoint(out p1);

				Console.WriteLine(p1.X);

				CopyPoint(out p2, in p1);

				Console.WriteLine(p2.X);
			}

			Console.WriteLine();

			for (int i = 0; i < 5; i++) {
				InitPoint(out Point p1);

				Console.WriteLine(p1.X);

				CopyPoint(out Point p2, in p1);

				Console.WriteLine(p2.X);
			}

			Console.WriteLine();

			{
				Point p = new Point();
				p.X = 42;

				TestReadonlyness(in p, ref p);
			}
		}
	}
}
